sysuse lifeexp, clear

label var lexp "Life expectancy, years" 

qplot lexp, yla(, ang(h)) saving(lifeexp_qplot, asis replace) 
more 

gen skewness = . 
gen kurtosis = . 
set seed 280352 
gen shuffle = . 
gen i = _n 
gen byte included = . 
qui forval i = 1/`=_N' { 
	replace shuffle = uniform()
	sort shuffle 
	su lexp, detail, in 1/`i' 
	replace skew = r(skewness) if i == `i' 
	replace kurt = r(kurtosis) if i == `i' 
	replace included = r(min) == 54 if i == `i' 
}

separate skewness, by(included) veryshortlabel 
separate kurtosis, by(included) veryshortlabel
local la `" 17 `" "17" "25%" "' 34 `" "34" "50%" "' 51 `" "51" "75%" "' 68 `" "68" "100%" "' "'
scatter skewness? i, yti(skewness) xla(`la') yla(-1 0 1, ang(h)) xsc(titlegap(3)) xti(subsample size) ms(Oh O) legend(ring(0) pos(1) col(1) order(1 "out" 2 "in")) saving(lifeexp_skewness, asis replace)
more 
scatter kurtosis? i, yti(kurtosis) xla(`la') yla(, ang(h)) xsc(titlegap(3)) xti(subsample size) ms(Oh O) legend(ring(0) pos(1) col(1) order(1 "out" 2 "in")) saving(lifeexp_kurtosis, asis replace) 
