mata : 

real lmom_w(real scalar n, real scalar m) 
{ 
	real scalar i, j 
	real vector c, cl, cr
	real matrix W 

	W = J(n, m, 1) 
	c = cl = cr = J(m, 1, n) 
	for (j = 2; j <= m; j++) 
		c[j] = c[j - 1] * (n - j - 1)/j 
	}

	for(i = 1; i <= n; i++) { 
		cl[1] = i - 1
		cr[1] = n - i 
		for(j = 2; j <= m; j++) { 
			cl[j] = cl[j - 1] * (i - j)/j
			cr[j] = cr[j - 1] * (n - i - j + 1)/j 
		}                         
		
		W[i, 2] = (cl[1] - cr[1]) / c[2] / 2
		W[i, 3] = (cl[2] - 2 * cl[1] * cr[1] + cr[2]) / c[3] / 3 
		W[i, 4] = (cl[3] - 3 * cl[2] * cr[1] + 3 * cl[1] * cr[2] - cr[3]) / c[4] / 4
	}

	return(W)  
}  	

void lmom_w_variables(real scalar n) 
{ 
	real scalar c2, c3, c4, cl1, cl2, cl3, cr1, cr2, cr3
	real matrix W 

	W = J(n, 4, 1) 
	c2 = (n - 1)/2 
	c3 = c2 * (n - 2)/3
	c4 = c3 * (n - 3)/4

	for(i = 1; i <= n; i++) { 
		cl1 = i - 1
		cl2 = cl1 * (i - 1 - 1)/2
		cl3 = cl2 * (i - 1 - 2)/3
		cr1 = n - i 
		cr2 = cr1 * (n - i - 1)/2
		cr3 = cr2 * (n - i - 2)/3
		W[i, 2] = (cl1 - cr1) / c2 / 2
		W[i, 3] = (cl2 - 2 * cl1 * cr1 + cr2) / c3 / 3 
		W[i, 4] = (cl3 - 3 * cl2 * cr1 + 3 * cl1 * cr2 - cr3) / c4 / 4
	}

	(void) st_addvar("double", ("W1", "W2", "W3", "W4"))
	st_store(., ("W1", "W2", "W3", "W4"), W) 
}  	

end

